﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;
using FarPoint.Win.Spread.CellType;
using System.Globalization;

namespace SpreadWinDemo.Borders
{
  public partial class Borders : Form
  {
    Color[] ColorArray = new Color[] { Color.Red, System.Drawing.Color.Green, System.Drawing.Color.Blue, System.Drawing.Color.Black };
    ComplexBorderSideStyle[] LineStyleArray = new ComplexBorderSideStyle[] { ComplexBorderSideStyle.DashDotDot, ComplexBorderSideStyle.MediumLine, ComplexBorderSideStyle.ThinLine, ComplexBorderSideStyle.DoubleLine };
    public Borders()
    {
      InitializeComponent();
      InitializeComboBox();
      InitializeSample();
    }

    private void InitializeSample()
    {
        fpSpread1.Sheets.Count = 2;

        SheetView sheet = this.fpSpread1.Sheets[0];
        sheet.SheetName = "Basic border";
        sheet.EnableDiagonalLine = true;
        // Four cells have same border
        int index = 0;
        SetBorder(sheet.Cells[1, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 0)));
        SetBorder(sheet.Cells[1, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 1)));
        SetBorder(sheet.Cells[2, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 2)));
        SetBorder(sheet.Cells[2, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 3)));
        index = 1;
        SetBorder(sheet.Cells[4, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 0)));
        SetBorder(sheet.Cells[4, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 1)));
        SetBorder(sheet.Cells[5, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 2)));
        SetBorder(sheet.Cells[5, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 3)));
        index = 2;
        SetBorder(sheet.Cells[7, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 0)));
        SetBorder(sheet.Cells[7, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 1)));
        SetBorder(sheet.Cells[8, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 2)));
        SetBorder(sheet.Cells[8, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 3)));
        index = 3;
        SetBorder(sheet.Cells[10, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 0)));
        SetBorder(sheet.Cells[10, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 1)));
        SetBorder(sheet.Cells[11, 1], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 2)));
        SetBorder(sheet.Cells[11, 2], new ComplexBorderSide(GetBorderLineStyle(index), GetColor(index + 3)));

        // Four cells have same border, but border line are different
        SetCellsBorder(new Cell[] { sheet.Cells[1, 4], sheet.Cells[1, 5], sheet.Cells[2, 4], sheet.Cells[2, 5] }, 0);
        SetCellsBorder(new Cell[] { sheet.Cells[4, 4], sheet.Cells[4, 5], sheet.Cells[5, 4], sheet.Cells[5, 5] }, 1);
        SetCellsBorder(new Cell[] { sheet.Cells[7, 4], sheet.Cells[7, 5], sheet.Cells[8, 4], sheet.Cells[8, 5] }, 2);
        SetCellsBorder(new Cell[] { sheet.Cells[10, 4], sheet.Cells[10, 5], sheet.Cells[11, 4], sheet.Cells[11, 5] }, 3);

        // Four cells have different border
        index = 0;
        SetCellBorder(sheet.Cells[1, 7], index + 0);
        SetCellBorder(sheet.Cells[1, 8], index + 1);
        SetCellBorder(sheet.Cells[2, 7], index + 2);
        SetCellBorder(sheet.Cells[2, 8], index + 3);
        index = 1;
        SetCellBorder(sheet.Cells[4, 7], index + 0);
        SetCellBorder(sheet.Cells[4, 8], index + 1);
        SetCellBorder(sheet.Cells[5, 7], index + 2);
        SetCellBorder(sheet.Cells[5, 8], index + 3);
        index = 2;
        SetCellBorder(sheet.Cells[7, 7], index + 0);
        SetCellBorder(sheet.Cells[7, 8], index + 1);
        SetCellBorder(sheet.Cells[8, 7], index + 2);
        SetCellBorder(sheet.Cells[8, 8], index + 3);
        index = 3;
        SetCellBorder(sheet.Cells[10, 7], index + 0);
        SetCellBorder(sheet.Cells[10, 8], index + 1);
        SetCellBorder(sheet.Cells[11, 7], index + 2);
        SetCellBorder(sheet.Cells[11, 8], index + 3);

        // Merge cell border
        int rowIndex = 14;
        sheet.Cells[rowIndex, 2].RowSpan = 5;
        sheet.Cells[rowIndex, 2].ColumnSpan = 6;
        FarPoint.Win.ComplexBorder complexBorder1 = new FarPoint.Win.ComplexBorder(new FarPoint.Win.ComplexBorderSide(FarPoint.Win.ComplexBorderSideStyle.DashDotDot, System.Drawing.Color.Purple));
        sheet.Cells[rowIndex, 2].Border = new ComplexBorder(new FarPoint.Win.ComplexBorderSide(FarPoint.Win.ComplexBorderSideStyle.DashDotDot, System.Drawing.Color.Purple));

        //SetBorder(sheet.Cells[rowIndex, 2], new BorderLine(Color.Purple, ComplexBorderSideStyle.DashDotDot));
        SetBorder(sheet.Cells[rowIndex - 1, 3], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Red));
        SetBorder(sheet.Cells[rowIndex - 1, 6], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 1, 8], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 3, 8], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black));
        SetBorder(sheet.Cells[rowIndex + 5, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Red));
        SetBorder(sheet.Cells[rowIndex + 5, 3], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 3, 1], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 1, 1], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Black));

        rowIndex += 8;
        sheet.Cells[rowIndex, 2].RowSpan = 5;
        sheet.Cells[rowIndex, 2].ColumnSpan = 6;
        sheet.Cells[rowIndex, 2].Border = new ComplexBorder(new FarPoint.Win.ComplexBorderSide(FarPoint.Win.ComplexBorderSideStyle.DoubleLine, System.Drawing.Color.Purple));
        //SetBorder(sheet.Cells[rowIndex, 2], new BorderLine(Color.Purple, ComplexBorderSideStyle.Double));
        SetBorder(sheet.Cells[rowIndex - 1, 3], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Red));
        SetBorder(sheet.Cells[rowIndex - 1, 6], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 1, 8], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 3, 8], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black));
        SetBorder(sheet.Cells[rowIndex + 5, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Red));
        SetBorder(sheet.Cells[rowIndex + 5, 3], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 3, 1], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 1, 1], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Black));

        rowIndex += 8;
        sheet.Cells[rowIndex, 2].RowSpan = 5;
        sheet.Cells[rowIndex, 2].ColumnSpan = 6;
        sheet.Cells[rowIndex, 2].Border = new ComplexBorder(new FarPoint.Win.ComplexBorderSide(FarPoint.Win.ComplexBorderSideStyle.ThickLine, System.Drawing.Color.Purple));
        //SetBorder(sheet.Cells[rowIndex, 2], new BorderLine(Color.Purple, ComplexBorderSideStyle.Thick));
        SetBorder(sheet.Cells[rowIndex - 1, 3], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Red));
        SetBorder(sheet.Cells[rowIndex - 1, 6], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 1, 8], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 3, 8], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black));
        SetBorder(sheet.Cells[rowIndex + 5, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Red));
        SetBorder(sheet.Cells[rowIndex + 5, 3], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 3, 1], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 1, 1], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Black));

        rowIndex += 8;
        sheet.Cells[rowIndex, 2].RowSpan = 5;
        sheet.Cells[rowIndex, 2].ColumnSpan = 6;
        sheet.Cells[rowIndex, 2].Border = new ComplexBorder(new FarPoint.Win.ComplexBorderSide(FarPoint.Win.ComplexBorderSideStyle.MediumLine, System.Drawing.Color.Purple));
        //SetBorder(sheet.Cells[rowIndex, 2], new BorderLine(Color.Purple, ComplexBorderSideStyle.Medium));
        SetBorder(sheet.Cells[rowIndex - 1, 3], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Red));
        SetBorder(sheet.Cells[rowIndex - 1, 6], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 1, 8], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 3, 8], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black));
        SetBorder(sheet.Cells[rowIndex + 5, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Red));
        SetBorder(sheet.Cells[rowIndex + 5, 3], new ComplexBorderSide(ComplexBorderSideStyle.ThickLine, Color.Green));
        SetBorder(sheet.Cells[rowIndex + 3, 1], new ComplexBorderSide(ComplexBorderSideStyle.DoubleLine, Color.Blue));
        SetBorder(sheet.Cells[rowIndex + 1, 1], new ComplexBorderSide(ComplexBorderSideStyle.DashDotDot, Color.Black));

        // Diagonal line border
        SetBorder(sheet.Cells[3, 3], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet.Cells[6, 3], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet.Cells[9, 3], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet.Cells[3, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumDashDot, Color.Black), true);
        SetBorder(sheet.Cells[6, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumDashDotDot, Color.Black), true);
        SetBorder(sheet.Cells[9, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumDashDot, Color.Black), true);

        int count = LineStyleArray.Length;
        for (int l = 0; l < count; l++) // left side border of joint
        {
            int rows = 0;
            for (int t = 0; t < count; t++) // top side border of joint
            {
                for (int r = 0; r < count; r++) // right side border of joint
                {
                    for (int b = 0; b < count; b++) // bottom side border of joint
                    {
                        sheet.Cells[rows, l * 2 + 10].Border = l == count ? null : new ComplexBorder(new ComplexBorderSide(GetBorderLineStyle(l), GetColor(l)));
                        sheet.Cells[rows, l * 2 + 11].Border = t == count ? null : new ComplexBorder(new ComplexBorderSide(GetBorderLineStyle(t), GetColor(t)));
                        sheet.Cells[rows, l * 2 + 11].Border = r == count ? null : new ComplexBorder(new ComplexBorderSide(GetBorderLineStyle(r), GetColor(r)));
                        sheet.Cells[rows + 1, l * 2 + 10].Border = b == count ? null : new ComplexBorder(new ComplexBorderSide(GetBorderLineStyle(b), GetColor(b)));
                        rows += 2;
                    }
                }
            }
        }

        SheetView sheet2 = fpSpread1.Sheets[1];
        sheet2.SheetName = "Advanced border";
        sheet2.EnableDiagonalLine = true;

        sheet2.Rows[4].Height = 50;
        SetRotateText(sheet2.Cells[4, 2], "First name", 45);
        SetRotateText(sheet2.Cells[4, 3], "Last name", 45);
        SetRotateText(sheet2.Cells[4, 4], "Age", 45);
        SetRotateText(sheet2.Cells[4, 5], "Gender", 45);
        SetRotateText(sheet2.Cells[4, 6], "Score", 45);

        SetBorder(sheet2.Cells[4, 2], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet2.Cells[4, 3], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet2.Cells[4, 4], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet2.Cells[4, 5], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);
        SetBorder(sheet2.Cells[4, 6], new ComplexBorderSide(ComplexBorderSideStyle.MediumLine, Color.Black), true);

        sheet2.Cells[5, 2].Text = "John";
        sheet2.Cells[5, 3].Text = "Smith";
        sheet2.Cells[5, 4].Text = "18";
        sheet2.Cells[5, 5].Text = "Male";
        sheet2.Cells[5, 6].Text = "80";

        sheet2.Cells[6, 2].Text = "Micheal";
        sheet2.Cells[6, 3].Text = "Chang";
        sheet2.Cells[6, 4].Text = "21";
        sheet2.Cells[6, 5].Text = "Male";
        sheet2.Cells[6, 6].Text = "85";

        sheet2.Cells[7, 2].Text = "Jessica";
        sheet2.Cells[7, 3].Text = "Alba";
        sheet2.Cells[7, 4].Text = "23";
        sheet2.Cells[7, 5].Text = "Female";
        sheet2.Cells[7, 6].Text = "90";

        chkEnableDiagonalLine.Checked = fpSpread1.ActiveSheet.EnableDiagonalLine;
    }

    private void SetRotateText(Cell cell, string text, int angle)
    {
        TextCellType txt = new TextCellType();
        txt.TextOrientation = TextOrientation.TextRotateCustom;
        txt.TextRotationAngle = angle;
        cell.CellType = txt;
        cell.Text = text;
    }

    private void InitializeComboBox()
    {
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.DashDot);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.DashDotDot);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.Dashed);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.Dotted);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.DoubleLine);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.None);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.HairLine);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.MediumLine);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.MediumDashDot);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.MediumDashDotDot);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.MediumDashed);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.SlantedDashDot);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.ThickLine);
      this.lineStyleComboBox.Items.Add(ComplexBorderSideStyle.ThinLine);
      this.lineStyleComboBox.SelectedIndex = 0;

      System.Reflection.PropertyInfo[] properties = typeof(Color).GetProperties(System.Reflection.BindingFlags.Public | System.Reflection.BindingFlags.Static);
      foreach (System.Reflection.PropertyInfo property in properties)
      {
        this.borderColorComboBox.Items.Add(property.Name);
        this.gridlineColorComboBox.Items.Add(property.Name);
      }
      this.borderColorComboBox.SelectedIndex = 0;
      this.gridlineColorComboBox.SelectedIndex = 0;
    }
    private Color GetColor(int index)
    {
      return ColorArray[index % ColorArray.Length];
    }

    private ComplexBorderSideStyle GetBorderLineStyle(int index)
    {
      return LineStyleArray[index % LineStyleArray.Length];
    }

    private void SetCellsBorder(Cell[] cells, int index)
    {
      foreach (Cell cell in cells)
      {
        SetCellBorder(cell, index);
      }
    }

    private void SetCellBorder(Cell cell, int index)
    {
      ComplexBorderSide left = new ComplexBorderSide(GetBorderLineStyle(index + 0), GetColor(index + 0));
      ComplexBorderSide top = new ComplexBorderSide(GetBorderLineStyle(index + 1), GetColor(index + 1));
      ComplexBorderSide right = new ComplexBorderSide(GetBorderLineStyle(index + 2), GetColor(index + 2));
      ComplexBorderSide bottom = new ComplexBorderSide(GetBorderLineStyle(index + 3), GetColor(index + 3));
      cell.Border = new ComplexBorder(left, top, right, bottom);
    }

    private void setBorderButton_Click(object sender, EventArgs e)
    {
      SheetView sheet = this.fpSpread1.ActiveSheet;
      CellRange[] cellRanges = sheet.GetSelections();
      foreach (CellRange cellRange in cellRanges)
      {
        CellRange range = GetActualCellRange(cellRange, sheet.RowCount, sheet.ColumnCount);
        for (int i = 0; i < range.RowCount; i++)
        {
          for (int j = 0; j < range.ColumnCount; j++)
          {
            SetBorder(sheet.Cells[i + range.Row, j + range.Column], new ComplexBorderSide(GetBorderLineStyle(lineStyleComboBox.SelectedItem.ToString()), GetColor(borderColorComboBox.SelectedItem.ToString())));
          }
        }
      }
    }

    private void clearBorderButton_Click(object sender, EventArgs e)
    {
      SheetView sheet = this.fpSpread1.ActiveSheet;
      CellRange[] cellRanges = sheet.GetSelections();
      foreach (CellRange cellRange in cellRanges)
      {
        CellRange range = GetActualCellRange(cellRange, sheet.RowCount, sheet.ColumnCount);
        for (int i = 0; i < range.RowCount; i++)
        {
          for (int j = 0; j < range.ColumnCount; j++)
          {
            SetBorder(sheet.Cells[i + range.Row, j + range.Column], null);
          }
        }
      }
    }

    private ComplexBorderSideStyle GetBorderLineStyle(string name)
    {
      return (ComplexBorderSideStyle)Enum.Parse(typeof(ComplexBorderSideStyle), name, true);
    }

    private Color GetColor(string name)
    {
      return (Color)typeof(Color).GetProperty(name).GetValue(null, null);
    }

    private CellRange GetActualCellRange(CellRange cellRange, int rowCount, int columnCount)
    {
      if (cellRange.Row == -1 && cellRange.Column == -1)
      {
        return new CellRange(0, 0, rowCount, columnCount);
      }
      else if (cellRange.Row == -1)
      {
        return new CellRange(0, cellRange.Column, rowCount, cellRange.ColumnCount);
      }
      else if (cellRange.Column == -1)
      {
        return new CellRange(cellRange.Row, 0, cellRange.RowCount, columnCount);
      }

      return cellRange;
    }

    private void SetBorder(Cell cell, ComplexBorderSide border)
    {
        SetBorder(cell, border, false);
    }

    private void SetBorder(Cell cell, ComplexBorderSide border, bool diagonalLine)
    {
      if (border == null)
      {
        cell.ResetBorder();
        //cell.Border = null;
      }
      else
      {
          if (!diagonalLine)
            cell.Border = new ComplexBorder(border, border, border, border);
          else
              cell.Border = new ComplexBorder(border, border, border, border, border, true, true);
      }
    }



    private void setGridLineButton_Click(object sender, EventArgs e)
    {
      int index = -1;
      int index1 = -1;
      int.TryParse(borderColorComboBox.SelectedItem.ToString(), out index);
      int.TryParse(lineStyleComboBox.SelectedItem.ToString(), out index1);
      this.fpSpread1.ActiveSheet.VerticalGridLine = new GridLine(GridLineType.Flat, GetColor(this.gridlineColorComboBox.SelectedItem.ToString()));
      this.fpSpread1.ActiveSheet.HorizontalGridLine = new GridLine(GridLineType.Flat, GetColor(this.gridlineColorComboBox.SelectedItem.ToString()));
    }
    GridLine backupVerticalGrid = null;
    GridLine backupHorizontalGrid = null;
    private void showGridLine_CheckedChanged(object sender, EventArgs e)
    {
      if (!showGridLine.Checked)
      {
        backupVerticalGrid = this.fpSpread1.ActiveSheet.VerticalGridLine;
        backupHorizontalGrid = this.fpSpread1.ActiveSheet.HorizontalGridLine;
        this.fpSpread1.ActiveSheet.VerticalGridLine = new GridLine(GridLineType.None, Color.Transparent);
        this.fpSpread1.ActiveSheet.HorizontalGridLine = new GridLine(GridLineType.None, Color.Transparent);
      }
      else
      {
        this.fpSpread1.ActiveSheet.VerticalGridLine = backupVerticalGrid;
        this.fpSpread1.ActiveSheet.HorizontalGridLine = backupHorizontalGrid;
      }
    }

    private void btnShowBorderDialog_Click(object sender, EventArgs e)
    {
        FarPoint.Win.Spread.Design.BorderEditor be = new FarPoint.Win.Spread.Design.BorderEditor(fpSpread1);
        be.ShowDialog(fpSpread1);        
    }

    private void chkEnableDiagonalLine_CheckedChanged(object sender, EventArgs e)
    {
        fpSpread1.ActiveSheet.EnableDiagonalLine = chkEnableDiagonalLine.Checked;
    }

    private void fpSpread1_ActiveSheetChanged(object sender, EventArgs e)
    {
        chkEnableDiagonalLine.Checked = fpSpread1.ActiveSheet.EnableDiagonalLine;
    }

    private void comboBox1_SelectedValueChanged(object sender, EventArgs e)
    {
        if (cboRotationAngle.SelectedItem == null || updateCellSetting) return;
        SheetView sheet = fpSpread1.ActiveSheet;


        fpSpread1.SuspendLayout();
        CellRange[] cellRanges = sheet.GetSelections();
        foreach (CellRange cellRange in cellRanges)
        {
            CellRange range = GetActualCellRange(cellRange, sheet.RowCount, sheet.ColumnCount);
            for (int i = range.Row; i < range.Row + range.RowCount; i++)
            {
                for (int j = range.Column; j < range.Column + range.ColumnCount; j++)
                {
                    TextCellType txt = new TextCellType();
                    txt.TextOrientation = TextOrientation.TextRotateCustom;
                    txt.TextRotationAngle = int.Parse(cboRotationAngle.SelectedItem as string);
                    ActiveSheet.Cells[i, j].CellType = txt;
                }
            }
        }
        fpSpread1.ResumeLayout(true);
    }

    private SheetView ActiveSheet
    {
        get { return fpSpread1.ActiveSheet; }
    }

    private bool updateCellSetting = false;
    private void fpSpread1_CellClick(object sender, CellClickEventArgs e)
    {
        updateCellSetting = true;
        ITextOrientationSupport2 oct = ActiveSheet.Cells[e.Row, e.Column].CellType as ITextOrientationSupport2;
        if (oct != null)
        {
            cboRotationAngle.SelectedItem = oct.TextRotationAngle.ToString(CultureInfo.InvariantCulture);
        }
        else
        {
            cboRotationAngle.SelectedIndex = -1;
        }
        updateCellSetting = false;
    }
  }
}
