﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread.DrawingSpace;
using FarPoint.Win.Spread.Model;
using FarPoint.Win.Spread;

namespace SpreadWinDemo.CameraShapeForm
{
  public partial class CameraShapeForm : Form
  {
    public CameraShapeForm()
    {
      InitializeComponent();
    }
    private bool creatingCameraShape = false;
    private string cameraShapeFormula = null;
    private void EditCameraToolStripMenuItem_Click(object sender, EventArgs e)
    {
      SpreadCameraShape.ShowSelectDataForm(this, FpSpread1, (SpreadCameraShape)FpSpread1.ActiveWindowlessObject);
    }

    private void NewCameraToolStripMenuItem_Click(object sender, EventArgs e)
    {
      CellRange cellRange = FpSpread1.ActiveSheet.GetSelection(0);
      if (cellRange == null)
        cellRange = new CellRange(FpSpread1.ActiveSheet.ActiveRowIndex, FpSpread1.ActiveSheet.ActiveColumnIndex, 1, 1);
      cameraShapeFormula = "'" + FpSpread1.ActiveSheet.SheetName + "'!" + FpSpread1.ActiveSheet.Cells[cellRange.Row, cellRange.Column, cellRange.Row + cellRange.RowCount - 1, cellRange.Column + cellRange.ColumnCount - 1].ToString(FpSpread1.ActiveSheet.Cells[cellRange.Row, cellRange.Column]);
      FpSpread1.SetCursor(CursorType.Normal, Cursors.Cross);
      creatingCameraShape = true;
    }

    private void FpSpread1_CellClick(object sender, FarPoint.Win.Spread.CellClickEventArgs e)
    {
      if (creatingCameraShape && e.Button == MouseButtons.Left && !e.ColumnHeader && !e.ColumnFooter && !e.RowHeader)
      {
        SpreadCameraShape newCameraShape = new SpreadCameraShape(cameraShapeFormula);
        Point p = MousePosition;
        Rectangle cellRectangle;
        p = FpSpread1.PointToClient(p);
        cellRectangle = FpSpread1.GetCellRectangle(FpSpread1.GetActiveRowViewportIndex(), FpSpread1.GetActiveColumnViewportIndex(), e.Row, e.Column);
        FpSpread1.ActiveSheet.AddShape(newCameraShape, e.Row, e.Column);
        newCameraShape.Location = new Point(newCameraShape.Location.X + (p.X - cellRectangle.X), newCameraShape.Location.Y + (p.Y - cellRectangle.Y));
        creatingCameraShape = false;
        FpSpread1.SetCursor(CursorType.Normal, Cursors.Default);
      }
    }

    private void newCameraShapeToolStripMenuItem_Click(object sender, EventArgs e)
    {
        editToolStripMenuItem.Enabled = (FpSpread1.ActiveWindowlessObject is SpreadCameraShape);
    }
  }
}
