﻿using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using FarPoint.Win.Spread.DrawingSpace;
using System.Drawing.Drawing2D;
using System.Windows.Forms;
using System.Drawing;

public class SpreadPropertyGrid : PropertyGrid, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.DoubleClick;
  public virtual FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    set { _activation = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }

  public void ControlPaint(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    string str = null;
    if ((value != null))
    {
      if (value is string)
      {
        str = Convert.ToString(value);
      }
      else
      {
        str = value.ToString();
      }
    }
    Region rgn = g.Clip;
    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);

    g.FillRectangle(new SolidBrush(this.BackColor), r);
    g.DrawString("PropertyGrid", Font, new SolidBrush(Color.White), r.X, r.Y);
    g.SetClip(rgn, CombineMode.Replace);
  }

}

public class SpreadTextBox : TextBox, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.DoubleClick;
  public SpreadTextBox()
  {
    this.TextChanged += Me_TextChanged;

  }
  public virtual FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    // _activation = Value
    set { }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }


  public void ControlPaint(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    Region rgn = g.Clip;
    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);
    g.FillRectangle(new SolidBrush(this.BackColor), r);
    //g.FillRectangle(New SolidBrush(Me.BackColor), r.X - 120, r.Y - 120, r.Width, r.Height)
    g.DrawString(this.Text, Font, new SolidBrush(this.ForeColor), r.X, r.Y);
    g.SetClip(rgn, CombineMode.Replace);
  }

  public void Me_TextChanged(object sender, EventArgs e)
  {
    this.BackColor = Color.Beige;
  }
}

public class SpreadRadioButton : RadioButton, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.Click;
  public SpreadRadioButton()
  {
    this.CheckedChanged += Me_CheckChanged;
  }
  public virtual FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    // _activation = Value
    set { }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }

  public void ControlPaint(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    Region rgn = g.Clip;

    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);

    r = new Rectangle(r.X, r.Y, Math.Min(this.Width, 12), Math.Min(this.Height, 16));

    if (this.Checked == true)
    {
      System.Windows.Forms.ControlPaint.DrawRadioButton(g, r, ButtonState.Checked);
    }
    else
    {
      System.Windows.Forms.ControlPaint.DrawRadioButton(g, r, ButtonState.Normal);
    }
    if ((this.ForeColor.IsEmpty))
    {
      g.DrawString(this.Text, this.Font, new SolidBrush(Color.Black), r.X + r.Width, r.Y);
    }
    else
    {
      g.DrawString(this.Text, this.Font, new SolidBrush(this.ForeColor), r.X + r.Width, r.Y);
    }
    g.SetClip(rgn, CombineMode.Replace);
  }


  public void Me_CheckChanged(object sender, System.EventArgs e)
  {
    this.BackColor = Color.Plum;


  }

}

public class SpreadCheckBox : CheckBox, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.Click;
  public SpreadCheckBox()
  {
    this.CheckStateChanged += Me_CheckStateChanged;
  }
  public virtual FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    set { _activation = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }

  public void ControlPaint(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    Region rgn = g.Clip;
    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);

    r = new Rectangle(r.X, r.Y, this.Width, this.Height);


    if (isSelected == true)
    {
      System.Windows.Forms.ControlPaint.DrawCheckBox(g, r, ButtonState.Checked);
    }
    else
    {
      System.Windows.Forms.ControlPaint.DrawCheckBox(g, r, ButtonState.Normal);
    }

    g.SetClip(rgn, CombineMode.Replace);
  }


  public void Me_CheckStateChanged(object sender, System.EventArgs e)
  {
    if (this.CheckState == System.Windows.Forms.CheckState.Checked)
    {
      this.BackColor = Color.Green;
    }
    else
    {
      this.BackColor = Color.Coral;
    }
  }

}

public class SpreadComboBox : ComboBox, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.Click;
  public SpreadComboBox()
  {
    this.SelectedValueChanged += Me_SelectedValueChanged;
  }
  public virtual FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    // _activation = Value
    set { }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public virtual FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }

  public void ControlPaint(Graphics g, Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    Region rgn = g.Clip;
    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);
    r = new Rectangle(r.X, r.Y, this.Width, this.Height);
    g.FillRectangle(new SolidBrush(Color.Yellow), r);
    g.DrawString("ComboBox", Font, new SolidBrush(Color.Black), r.X, r.Y);
    r.X = r.X + r.Width - SystemInformation.CaptionButtonSize.Width;
    r.Width = SystemInformation.CaptionButtonSize.Width;
    System.Windows.Forms.ControlPaint.DrawComboButton(g, r, ButtonState.Normal);

    g.SetClip(rgn, CombineMode.Replace);
  }

  public void Me_SelectedValueChanged(object sender, EventArgs e)
  {
    this.BackColor = Color.Orange;
  }

}

public class SpreadButton : Button, FarPoint.Win.Spread.DrawingSpace.IEmbeddedControlSupport
{

  private FarPoint.Win.Spread.DrawingSpace.Moving _moving = Moving.None;
  private FarPoint.Win.Spread.DrawingSpace.Sizing _sizing = Sizing.None;

  private FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy _activation = ChildActivationPolicy.Click;
  public SpreadButton()
  {
    this.Click += Me_Click;
  }

  public FarPoint.Win.Spread.DrawingSpace.ChildActivationPolicy ActivationPolicy
  {
    get { return _activation; }
    //_activation = value
    set { }
  }

  public FarPoint.Win.Spread.DrawingSpace.Moving CanMove
  {
    get { return _moving; }
    set { _moving = value; }
  }

  public FarPoint.Win.Spread.DrawingSpace.Sizing CanSize
  {
    get { return _sizing; }
    set { _sizing = value; }
  }

  public void ControlPaint(System.Drawing.Graphics g, System.Drawing.Rectangle r, FarPoint.Win.Spread.Appearance appearance, object value, bool isSelected, bool isLocked, float zoomFactor)
  {
    Region rgn = g.Clip;
    g.SetClip(r, System.Drawing.Drawing2D.CombineMode.Intersect);
    r = new Rectangle(r.X, r.Y, this.Width, this.Height);
    g.FillRectangle(new SolidBrush(Color.Yellow), r);
    System.Windows.Forms.ControlPaint.DrawButton(g, r, ButtonState.All);
    g.SetClip(rgn, CombineMode.Replace);

  }

  public void Me_Click(object sender, System.EventArgs e)
  {
    this.BackColor = Color.Red;
  }
}

