﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using GrapeCity.Spreadsheet;
using FarPoint.Win.Spread.CellType;
using Microsoft.Win32;
using System.IO;

namespace SpreadWinDemo.DataValidation
{
  public partial class DataValidation : Form
  {
    string dbPath = string.Empty;
    string fileName = "\\sampleDataValidation_1.xml";
    public DataValidation()
    {
      InitializeComponent();
      fpSpread1.AllowCellOverflow = true;
      fpSpread1.Sheets[0].Cells[0, 0].Text = @"Select one cellrange then click on ""AddDataValidation -> Add DataValidation..."" button to set Validation";
      fpSpread1.Sheets[0].Cells[0, 0].Font = new System.Drawing.Font("Times New Roman", 10, System.Drawing.FontStyle.Bold);
      setDataFpSpread2();
     RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");
        if (regKey != null)
          dbPath = (string)regKey.GetValue("v" + GCVersionUtil.ProductVersion);
        if (!File.Exists(dbPath + fileName))
          dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER + "\\Common\\";
        if (!File.Exists(dbPath + fileName))
          dbPath = "Data\\";
        //Local Database Path
        dbPath += fileName;
       
      fpSpread3.Open(dbPath );

    }
    #region FpSpread1

    int row1 = 0;
    int row2 = 0;
    int col1 = 0;
    int col2 = 0;



    private void setValidation_Click(object sender, EventArgs e)
    {
      fpSpread1.ShowDataValidationForm(new Form(),true);

    }


    private void fpSpread1_SelectionChanged(object sender, FarPoint.Win.Spread.SelectionChangedEventArgs e)
    {
      FarPoint.Win.Spread.Model.CellRange cr;
      cr = e.View.Sheets[0].GetSelection(0);
      row1 = cr.Row;
      row2 = cr.Row + cr.RowCount - 1;
      col1 = cr.Column;
      col2 = cr.Column + cr.ColumnCount - 1;

    }

    private void clearDataValidation_Click(object sender, EventArgs e)
    {
      fpSpread1.ActiveSheet.Validations.Clear();
       fpSpread1.ActiveSheet.Validations.ClearCircles();
    }

    private void clearRangeDataValidation_Click(object sender, EventArgs e)
    {
      fpSpread1.ActiveSheet.Validations.Clear(row1, col1, row2, col2);
      fpSpread1.ActiveSheet.Validations.ClearCircles();
      fpSpread1.ActiveSheet.Validations.CircleInvalid();
    }

    private void CircleInvalid_Click(object sender, EventArgs e)
    {
      fpSpread1.ActiveSheet.Validations.CircleInvalid();
    }

     private void removeCircleInvalid_Click(object sender, EventArgs e)
    {
      fpSpread1.ActiveSheet.Validations.ClearCircles();
    }

    #endregion

    #region FpSpread2
    public void setDataFpSpread2()
    {
      fpSpread2.Sheets.Count = 2;
      fpSpread2.Sheets[0].SheetName = "Products";
      fpSpread2.Sheets[1].SheetName = "OrderForm";
      TextCellType text = new TextCellType();
      text.WordWrap = true;


      //Sheet 1
      fpSpread2.Sheets[0].SetClip(0, 0, 3, 1, "Cat\nMarkers\nPens");
      fpSpread2.Sheets[0].SetClip(0, 2, 5, 1, "Markers\nGold\nPermanent\nSilver\nWhite paint");
      fpSpread2.Sheets[0].SetClip(0, 5, 10, 1, "Pens\nFlexgrip highlighter\nGripper ball\nRetractable\nroundedge stick pens\nRubber grip\nRubberstik\nStainless steel ballpoint\nStick pen\nTwist erase pencil");


      fpSpread2.Sheets[0].SetClip(1, 3, 5, 1, "4.29\n1.49\n3.99\n3.99");
      fpSpread2.Sheets[0].SetClip(1, 6, 10, 1, "1.49\n1.29\n4.99\n1.2\n0.95\n0.69\n9.99\n0.59\n6.49");

      fpSpread2.Sheets[0].Cells[1, 3, 4, 3].CellType = new CurrencyCellType();
      fpSpread2.Sheets[0].Cells[1, 6, 9, 6].CellType = new CurrencyCellType();

      fpSpread2.Sheets[0].Rows[0].Font = new System.Drawing.Font("MS Sans Serif", 8, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[0].AddCustomName("Categories", "Products!$A$2:$A$3", 0, 0, false, "");
      fpSpread2.Sheets[0].AddCustomName("Markers", "Products!$C$2:$C$5", 0, 0, false, "");
      fpSpread2.Sheets[0].AddCustomName("MarkersList", "Products!$C$2:$D$5", 0, 0, false, "");
      fpSpread2.Sheets[0].AddCustomName("Pens", "Products!$F$2:$F$10", 0, 0, false, "");
      fpSpread2.Sheets[0].AddCustomName("PensList", "Products!$F$2:$G$10", 0, 0, false, "");
      fpSpread2.Sheets[0].Columns.Default.Width = 80;
      fpSpread2.Sheets[0].Columns[1].Width = 40;
      fpSpread2.Sheets[0].Rows.Default.Height = 22;
      fpSpread2.Sheets[0].Cells["H3"].Text = "The named ranges on this worksheet provide the data for the dropdown lists on the Order Form. They also are used by the VLOOKUP formula, to extract the unit price of the item.";
      fpSpread2.Sheets[0].Cells["H3"].ColumnSpan = 3;
      fpSpread2.Sheets[0].Cells["H3"].RowSpan = 6;
      fpSpread2.Sheets[0].Cells["H3"].Font = new System.Drawing.Font("MS Sans Serif", 10, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[0].Cells["H3"].ForeColor = System.Drawing.Color.Red;
      fpSpread2.Sheets[0].Cells["H3"].CellType = text;
      fpSpread2.Sheets[0].Cells["H3"].BackColor = System.Drawing.Color.FromArgb(204, 255, 255);
      fpSpread2.Sheets[0].Cells["A1:A3"].BackColor = System.Drawing.Color.FromArgb(235, 241, 222);
      fpSpread2.Sheets[0].Cells["C1:D5"].BackColor = System.Drawing.Color.FromArgb(235, 241, 222);
      fpSpread2.Sheets[0].Cells["F1:G10"].BackColor = System.Drawing.Color.FromArgb(235, 241, 222);

      //Sheet 2
      fpSpread2.Sheets[1].Cells["B2"].Value = "Order Form";
      fpSpread2.Sheets[1].Cells["B2"].Font = new System.Drawing.Font("MS Sans Serif", 12, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[1].Cells["F2"].Formula = "Today()";
      fpSpread2.Sheets[1].Cells["F2"].CellType = new DateTimeCellType();
      fpSpread2.Sheets[1].Cells["B5:F14"].Border = new FarPoint.Win.LineBorder(System.Drawing.Color.Black);
      fpSpread2.Sheets[1].SetClip(4, 1, 1, 5, "Cat\tDesc\t Unit Cost\t Units\t Total ");
      fpSpread2.Sheets[1].Cells["B5:F5"].Font = new System.Drawing.Font("MS Sans Serif", 8, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[1].Cells["B6:C13"].BackColor = System.Drawing.Color.LightYellow;
      fpSpread2.Sheets[1].Cells["E6:E13"].BackColor = System.Drawing.Color.LightYellow;
      fpSpread2.Sheets[1].Cells["B14"].ColumnSpan = 4;
      fpSpread2.Sheets[1].Cells["B14"].Text = "SubTotal";
      fpSpread2.Sheets[1].Cells["B14"].HorizontalAlignment = FarPoint.Win.Spread.CellHorizontalAlignment.Right;
      GrapeCity.Spreadsheet.DataValidation dv1 = fpSpread2.Sheets[1].Validations.Add(5, 1, 12, 1, DataValidationType.List,DataValidationErrorStyle.Warning, DataValidationOperator.Equal,  "=Categories", null);
      GrapeCity.Spreadsheet.DataValidation dv2 = fpSpread2.Sheets[1].Validations.Add(5, 2, 12, 2, DataValidationType.List, DataValidationErrorStyle.Warning,DataValidationOperator.Equal,  "=INDIRECT(B6)", null);

      fpSpread2.Sheets[1].Cells["D6:D13"].Formula = @"IF(C6="""","""",VLOOKUP(C6,INDIRECT(B6&""List""),2,FALSE))";
      fpSpread2.Sheets[1].Cells["F6:F13"].Formula = @"IF(D6="""","""",D6*E6)";
      fpSpread2.Sheets[1].Cells["D6:D13"].CellType = new CurrencyCellType();
      fpSpread2.Sheets[1].Cells["F6:F19"].CellType = new CurrencyCellType();
      fpSpread2.Sheets[1].Cells["E6:E13"].Value = 10;
      fpSpread2.Sheets[1].Cells["F14"].Formula = "SUM(F6: F13)";
      fpSpread2.Sheets[1].Cells["D17:F19"].Border = new FarPoint.Win.LineBorder(System.Drawing.Color.Black);
      CheckBoxCellType ck1 = new CheckBoxCellType();
      ck1.TextFalse = "PST";
      ck1.TextTrue = "PST";
      CheckBoxCellType ck2 = new CheckBoxCellType();
      ck2.TextFalse = "GST";
      ck2.TextTrue = "GST";
      fpSpread2.Sheets[1].Cells["D17"].CellType = ck1;
      fpSpread2.Sheets[1].Cells["D18"].CellType = ck2;

      fpSpread2.Sheets[1].Cells["E17"].Value = 0.08;
      fpSpread2.Sheets[1].Cells["E18"].Value = 0.07;
      fpSpread2.Sheets[1].Cells["E17:E18"].CellType = new PercentCellType();
      fpSpread2.Sheets[1].Cells["F17"].Formula = "D17*F14*E17";
      fpSpread2.Sheets[1].Cells["F18"].Formula = "D18*F14*E18";
      fpSpread2.Sheets[1].Cells["D19"].Text = "Total";
      fpSpread2.Sheets[1].Cells["D19"].ColumnSpan = 2;
      fpSpread2.Sheets[1].Cells["F19"].Formula = "F14+F17+F18";
      fpSpread2.Sheets[1].Cells["D19:F19"].Font = new System.Drawing.Font("MS Sans Serif", 8, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[1].Cells["B5:F5"].Font = new System.Drawing.Font("MS Sans Serif", 8, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[1].Columns[1].Width = 100;
      fpSpread2.Sheets[1].Columns[2].Width = 150;
      fpSpread2.Sheets[1].Columns[3].Width = 80;
      fpSpread2.Sheets[1].Rows.Default.Height = 22;


      fpSpread2.Sheets[1].Cells["H5"].Text = "Select a Category, then a Description. The dropdown lists are created through Data Validation.The Unit Cost is extracted by a VLOOKUP formula.";
      fpSpread2.Sheets[1].Cells["H5"].ColumnSpan = 3;
      fpSpread2.Sheets[1].Cells["H5"].RowSpan = 6;
      fpSpread2.Sheets[1].Cells["H5"].Font = new System.Drawing.Font("MS Sans Serif", 10, System.Drawing.FontStyle.Bold);
      fpSpread2.Sheets[1].Cells["H5"].ForeColor = System.Drawing.Color.Red;
      fpSpread2.Sheets[1].Cells["H5"].CellType = text;
      fpSpread2.Sheets[1].Cells["H5"].BackColor = System.Drawing.Color.FromArgb(204, 255, 255);
      fpSpread2.AllowUserFormulas = true;


    }
    #endregion

  }
}

