﻿using FarPoint.Win.Spread;
using FarPoint.Win.Spread.CellType;
using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;

namespace SpreadWinDemo.Features
{
  public partial class FooterFormula
  {
    public FooterFormula()
    {
      InitializeComponent();
      this.Load += new System.EventHandler(this.Form1_Load);
    }
    private void Form1_Load(System.Object sender, System.EventArgs e)
    {
      ColumnFooter colFooter2 = FpSpread1_Sheet1.ColumnFooter;
      InitFooter1();

      FpSpread1.Sheets[1].Cells[5, 2].Formula = "Footer1!C1";
      FpSpread1.Sheets[1].Cells[6, 2].Formula = "Footer1!C2";
    }

    private void InitFooter1()
    {
      ColumnFooter colFooter1 = FpSpread1.Sheets[0].ColumnFooter;
      colFooter1.Name = "Footer1";
      colFooter1.Rows[0].Height = FpSpread1.Sheets[0].ColumnFooter.Rows[1].Height = 30;

      colFooter1.Rows[0].BackColor = Color.FromArgb(26, 170, 66);
      colFooter1.Rows[1].BackColor = Color.FromArgb(255, 204, 153);

      colFooter1.Cells[0, 1].Text = "TOTALS: ";
      colFooter1.Cells[0, 1].ForeColor = Color.White;

      colFooter1.Cells[1, 1].ForeColor = Color.Red;
      colFooter1.Cells[1, 1].Text = "VARIANCE: ";

      CurrencyCellType ct = new CurrencyCellType();
      ct.DecimalSeparator = ",";
      ct.CurrencySymbol = "$";
      ct.DecimalPlaces = 2;
      for (int c = 2; c <= 12; c++)
      {
        colFooter1.Cells[0, c].CellType = ct;
        colFooter1.Cells[1, c].CellType = ct;

        //colFooter1.Cells[0, 2].Formula = "SUM(Sheet1!C6:Sheet1!C12)";
        colFooter1.Cells[0, c].Formula = string.Format("SUM(Sheet1!{0}6:Sheet1!{0}12)", Convert.ToChar(65 + c).ToString());

        //colFooter1.Cells[1, 2].Formula = "Footer1!C1-Sheet1!C14"; //Enhanced feature
        colFooter1.Cells[1, c].Formula = string.Format("Footer1!{0}1-Sheet1!{0}14", Convert.ToChar(65 + c).ToString());
      }
    }

    private void FpSpread1_ActiveSheetChanged(object sender, System.EventArgs e)
    {

    }
  }
}