﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;

namespace SpreadWinDemo.MultipleHeaders
{
  public partial class MultipleHeaders : Form
  {
    public MultipleHeaders()
    {
      InitializeComponent();
    }
    private void InitializeSample()
    {
      SheetView sheet = this.fpSpread1.ActiveSheet;
      sheet.RowCount = 10;
      sheet.ColumnCount = 8;
      sheet.ColumnHeader.RowCount = 2;
      sheet.RowHeader.ColumnCount = 2;
      sheet.AddColumnHeaderSpanCell(0, 0, 2, 1);
      sheet.AddColumnHeaderSpanCell(0, 0, 2, 1);
      sheet.ColumnHeader.Cells[0, 0].Value = "State";
      sheet.AddColumnHeaderSpanCell(0, 1, 1, 2);
      sheet.ColumnHeader.Cells[0, 1].Value = "Company";
      sheet.AddColumnHeaderSpanCell(0, 3, 1, 2);
      sheet.ColumnHeader.Cells[0, 3].Value = "Category";
      sheet.AddColumnHeaderSpanCell(0, 5, 1, 3);
      sheet.ColumnHeader.Cells[0, 3].Value = "Products";
      sheet.ColumnHeader.Cells[1, 1].Value = "GC";
      sheet.ColumnHeader.Cells[1, 2].Value = "MS";
      sheet.ColumnHeader.Cells[1, 3].Value = "License";
      sheet.ColumnHeader.Cells[1, 4].Value = "Activate";
      sheet.ColumnHeader.Cells[1, 5].Value = "Win";
      sheet.ColumnHeader.Cells[1, 6].Value = "Web";
      sheet.ColumnHeader.Cells[1, 7].Value = "XAML";
      sheet.AddRowHeaderSpanCell(0, 0, 3, 1);
      sheet.AddRowHeaderSpanCell(3, 0, 3, 1);
      sheet.AddRowHeaderSpanCell(6, 0, 3, 1);
      sheet.AddRowHeaderSpanCell(9, 0, 1, 2);
      sheet.RowHeader.Cells[0, 0].Value = ".NET";
      sheet.RowHeader.Cells[3, 0].Value = "Java";
      sheet.RowHeader.Cells[6, 0].Value = "HTML";
      sheet.RowHeader.Cells[9, 0].Value = "Total:";
      sheet.Cells[9, 0, 9, 7].Border = new FarPoint.Win.DoubleLineBorder(System.Drawing.SystemColors.WindowFrame, false, true, false, false);
      sheet.Cells[9, 0, 9, 7].Formula = "SUM(A1:A9)";
      FillSampleData(sheet, new CellRange(0, 0, 9, 8));
    }

    private void FillSampleData(SheetView sheet, CellRange range)
    {
      System.Random r = new System.Random();
      for (int i = 0; i < range.RowCount; i++)
      {
        for (int j = 0; j < range.ColumnCount; j++)
        {
          sheet.SetValue(range.Row + i, range.Column + j, r.Next(50, 300));
        }
      }
    }

    private void btnAddColumnHeader_Click(object sender, EventArgs e)
    {
      try
      {
        SheetView sheet = this.fpSpread1.ActiveSheet;
        sheet.ColumnHeader.RowCount += 1;
      }
      catch (System.Exception ex)
      {
        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK);
      }
    }

    private void btnRemoveColumnHeader_Click(object sender, EventArgs e)
    {
      try
      {
        SheetView sheet = this.fpSpread1.ActiveSheet;
        sheet.ColumnHeader.RowCount -= 1;
      }
      catch (System.Exception ex)
      {
        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK);
      }
    }

    private void btnAddRowHeader_Click(object sender, EventArgs e)
    {
      try
      {
        SheetView sheet = this.fpSpread1.ActiveSheet;
        sheet.RowHeader.ColumnCount += 1;
      }
      catch (System.Exception ex)
      {
        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK);
      }
    }

    private void btnRemoveRowHeader_Click(object sender, EventArgs e)
    {
      try
      {
        SheetView sheet = this.fpSpread1.ActiveSheet;
        sheet.RowHeader.ColumnCount -= 1;
      }
      catch (System.Exception ex)
      {
        MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK);
      }
    }

    private void MultipleHeaders_Load(object sender, EventArgs e)
    {
      InitializeSample();
    }
  }
}
