using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;

namespace SpreadWinDemo.Printing
{
  /// <summary>
  /// Summary description for Printing.
  /// </summary>
  public class Printing : System.Windows.Forms.Form
  {
    internal FarPoint.Win.Spread.FpSpread FpSpread1;
    private FarPoint.Win.Spread.SheetView FpSpread1_Sheet1;
    private System.Windows.Forms.Button button1;
    private System.Windows.Forms.Button button2;
    private System.Windows.Forms.Button button3;
    /// <summary>
    /// Required designer variable.
    /// </summary>
    private System.ComponentModel.Container components = null;

    public Printing()
    {
      //
      // Required for Windows Form Designer support
      //
      InitializeComponent();
      //
      // TODO: Add any constructor code after InitializeComponent call
      //
    }

    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    protected override void Dispose(bool disposing)
    {
      if (disposing)
      {
        if (components != null)
        {
          components.Dispose();
        }
      }
      base.Dispose(disposing);
    }

    #region Windows Form Designer generated code
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
      this.FpSpread1 = new FarPoint.Win.Spread.FpSpread();
      this.FpSpread1_Sheet1 = new FarPoint.Win.Spread.SheetView();
      this.button1 = new System.Windows.Forms.Button();
      this.button2 = new System.Windows.Forms.Button();
      this.button3 = new System.Windows.Forms.Button();
      ((System.ComponentModel.ISupportInitialize)(this.FpSpread1)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.FpSpread1_Sheet1)).BeginInit();
      this.SuspendLayout();
      // 
      // FpSpread1
      // 
      this.FpSpread1.AccessibleDescription = "";
      this.FpSpread1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                  | System.Windows.Forms.AnchorStyles.Left)
                  | System.Windows.Forms.AnchorStyles.Right)));
      this.FpSpread1.Location = new System.Drawing.Point(0, 0);
      this.FpSpread1.Name = "FpSpread1";
      this.FpSpread1.Sheets.AddRange(new FarPoint.Win.Spread.SheetView[] {
            this.FpSpread1_Sheet1});
      this.FpSpread1.Size = new System.Drawing.Size(667, 514);
      this.FpSpread1.TabIndex = 1;
      // 
      // FpSpread1_Sheet1
      // 
      this.FpSpread1_Sheet1.Reset();
      this.FpSpread1_Sheet1.SheetName = "Sheet1";
      // 
      // button1
      // 
      this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
      this.button1.Location = new System.Drawing.Point(21, 520);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(96, 32);
      this.button1.TabIndex = 2;
      this.button1.Text = "Clear Data";
      this.button1.Click += new System.EventHandler(this.button1_Click);
      // 
      // button2
      // 
      this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
      this.button2.Location = new System.Drawing.Point(163, 520);
      this.button2.Name = "button2";
      this.button2.Size = new System.Drawing.Size(112, 32);
      this.button2.TabIndex = 3;
      this.button2.Text = "Load Sample Data";
      this.button2.Click += new System.EventHandler(this.button2_Click);
      // 
      // button3
      // 
      this.button3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
      this.button3.Location = new System.Drawing.Point(316, 520);
      this.button3.Name = "button3";
      this.button3.Size = new System.Drawing.Size(128, 32);
      this.button3.TabIndex = 4;
      this.button3.Text = "Print";
      this.button3.Click += new System.EventHandler(this.button3_Click);
      // 
      // Printing
      // 
      this.AutoScaleDimensions = new System.Drawing.SizeF(96F, 96F);
      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi;
      this.BackColor = System.Drawing.Color.White;
      this.ClientSize = new System.Drawing.Size(665, 564);
      this.Controls.Add(this.button3);
      this.Controls.Add(this.button2);
      this.Controls.Add(this.button1);
      this.Controls.Add(this.FpSpread1);
      this.Name = "Printing";
      this.Text = "Printing";
      this.Load += new System.EventHandler(this.Printing_Load);
      ((System.ComponentModel.ISupportInitialize)(this.FpSpread1)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.FpSpread1_Sheet1)).EndInit();
      this.ResumeLayout(false);

    }
    #endregion
    string dbPath = string.Empty;
    string fileName = "\\print.xml";
    private SpreadWinDemo.PrintOpts printopts = new PrintOpts();

    private void Printing_Load(object sender, System.EventArgs e)
    {
      Microsoft.Win32.RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");       
      if (regKey != null)
        dbPath = regKey.GetValue("v" + GCVersionUtil.ProductVersion).ToString();
      if (!File.Exists(dbPath + fileName))
        dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER + "\\Common\\";
      if (!File.Exists(dbPath + fileName))
        dbPath = "Data\\";      
      FpSpread1.Open(dbPath + fileName);
      FarPoint.Win.Spread.DefaultSkins.Default.Apply(FpSpread1);  
    }

    private void button3_Click(object sender, System.EventArgs e)
    {
      Module1.pi.ColStart = FpSpread1.ActiveSheet.Models.Selection.AnchorColumn;
      Module1.pi.ColEnd = FpSpread1.ActiveSheet.Models.Selection.LeadColumn;
      Module1.pi.RowStart = FpSpread1.ActiveSheet.Models.Selection.AnchorRow;
      Module1.pi.RowEnd = FpSpread1.ActiveSheet.Models.Selection.LeadRow;

      if (printopts.IsDisposed)
      {
        printopts = new PrintOpts();
      }

      printopts.StartPage(this);
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      FpSpread1.Reset();
    }

    private void button2_Click(object sender, System.EventArgs e)
    {
      FpSpread1.Open(dbPath + fileName);
    }
  }
}
