﻿using FarPoint.Win.Spread;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SpreadWinDemo.ProtectedWorkBook
{
  public partial class ProtectedWorkBook : Form
  {
    public ProtectedWorkBook()
    {
      InitializeComponent();
      fpSpread1.Sheets.Count = 3;
      fpSpread1.SheetTabClick += new FarPoint.Win.Spread.SheetTabClickEventHandler(fpSpread1SheetTabClick);
      ckDisable.Checked = true;

      fpSpread1.Sheets[0].Cells[0, 1].ColumnSpan = 10;
      fpSpread1.Sheets[0].Cells[0, 1].Text = "When the Spread is structure protected, you can NOT do the actions like: adding, removing sheet!";
      fpSpread1.Sheets[0].Cells[0, 1].Font = new Font("Arial", 9f, FontStyle.Italic);

      fpSpread1.Sheets[0].Cells[10, 1].ColumnSpan = 9;
      fpSpread1.Sheets[0].Rows[10].Height = 100;
      fpSpread1.Sheets[0].Cells[10, 1].Text = "The Spread structure is UNPROTECTED!";
      fpSpread1.Sheets[0].Cells[10, 1].HorizontalAlignment = CellHorizontalAlignment.Center;
      fpSpread1.Sheets[0].Cells[10, 1].VerticalAlignment = CellVerticalAlignment.Center;
      fpSpread1.Sheets[0].Cells[10, 1].Font = new Font("Arial", 14f);
    }

    public Point getPosition()
    {
      Point point = new Point(0, 0);
      int i = fpSpread1.Sheets.IndexOf(fpSpread1.ActiveSheet);
      point.X = fpSpread1.RectangleToScreen(fpSpread1.GetSheetTabRectangle(i)).Left;
      point.Y = fpSpread1.RectangleToScreen(fpSpread1.GetSheetTabRectangle(i)).Bottom;
      return point;
    }

    private void fpSpread1SheetTabClick(object sender, FarPoint.Win.Spread.SheetTabClickEventArgs e)
    {
     if(MouseButtons.ToString()=="Right")
      {
        if (e.SheetTabIndex == fpSpread1.Sheets.IndexOf(fpSpread1.ActiveSheet))
      {
        contextMenuStrip1.Show(getPosition());
      }
      }
      
    }



    private void insertToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        fpSpread1.Sheets.Add(new SheetView());
      }
      catch
      {
        MessageBox.Show("This Spread was protected, pls unprotect it before doing action");
      }

    }

    private void deleteToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        fpSpread1.Sheets.Remove(fpSpread1.ActiveSheet);
      }
      catch
      {
        MessageBox.Show("This Spread was protected from changing structure, pls unprotect Spread before doing action");
      }


    }

    private void moveToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        fpSpread1.Sheets.Move(fpSpread1.Sheets.IndexOf(fpSpread1.ActiveSheet), fpSpread1.Sheets.Count - 1);
      }
      catch
      {
        MessageBox.Show("This Spread was protected from changing structure, pls unprotect Spread before doing action");
      }


    }

    private void hidenToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        fpSpread1.ActiveSheet.Visible = false;
      }
      catch
      {
        MessageBox.Show("This Spread was protected from changing structure, pls unprotect Spread before doing action");
      }

    }

    private void unhideToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        for (int i = 0; i < fpSpread1.Sheets.Count; i++)
        {
          fpSpread1.Sheets[i].Visible = true;
        }
      }
      catch
      {
        MessageBox.Show("This Spread was protected from changing structure, pls unprotect Spread before doing action");
      }

    }

    private void renameToolStripMenuItem_Click(object sender, EventArgs e)
    {
      try
      {
        fpSpread1.ActiveSheet.SheetName = fpSpread1.ActiveSheet.SheetName + "Changed";
      }
      catch
      {
        MessageBox.Show("This Spread was protected from changing structure, pls unprotect Spread before doing action");
      }

    }



    private void checkBox1_CheckedChanged(object sender, EventArgs e)
    {
      if (fpSpread1.IsProtectedStructure && ckDisable.Checked)
      {
        for (int i = 0; i < contextMenuStrip1.Items.Count; i++)
        {
          contextMenuStrip1.Items[i].Enabled = false;
        }
      }
      else
      {
        for (int i = 0; i < contextMenuStrip1.Items.Count; i++)
        {
          contextMenuStrip1.Items[i].Enabled = true;
        }
      }
          }
    private void protectWB_Click(object sender, EventArgs e)
    {
     
      if (passFirst.Text != passSecond.Text)
      {
        MessageBox.Show("Password is incorrect", fpSpread1.Name);
        this.ActiveControl = passFirst;
        return;
      }
      fpSpread1.SetProtect(true, passFirst.Text);
      MessageBox.Show("This Spread was protected from changing structure!", fpSpread1.Name);
      if (ckDisable.Checked)
      {
        for (int i = 0; i < contextMenuStrip1.Items.Count; i++)
        {
          contextMenuStrip1.Items[i].Enabled = false;
        }
      }      
      fpSpread1.Sheets[0].Cells[10, 1].Text = "The Spread structure is PROTECTED!";
      fpSpread1.Sheets[0].Cells[10, 1].BackColor = Color.Gray;
    }
    private void unprotectWB_Click(object sender, EventArgs e)
    {
     
      if (passFirst.Text != passSecond.Text)
      {
        MessageBox.Show("Password is incorrect", fpSpread1.Name);
        this.ActiveControl = passFirst;
        return;
      }
      fpSpread1.SetProtect(false, passFirst.Text);
      if (fpSpread1.IsProtectedStructure == false)
      {
        MessageBox.Show("This Spread was unprotected", fpSpread1.Name);
        for (int i = 0; i < contextMenuStrip1.Items.Count; i++)
        {
          contextMenuStrip1.Items[i].Enabled = true;
        }
        fpSpread1.Sheets[0].Cells[10, 1].Text = "The Spread structure is UNPROTECTED!";
        fpSpread1.Sheets[0].Cells[10, 1].BackColor = Color.Empty;
      }
      else
      {
        MessageBox.Show("Password is uncorrect", fpSpread1.Name);
      }

    }
  }
}
