﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;

namespace SpreadWinDemo.CellSpans
{
  public partial class CellSpans : Form
  {
    public CellSpans()
    {
      InitializeComponent();
    }
    private CellRange GetActualCellRange(CellRange cellRange, int rowCount, int columnCount)
    {
      if (cellRange.Row == -1 && cellRange.Column == -1)
      {
        return new CellRange(0, 0, rowCount, columnCount);
      }
      else if (cellRange.Row == -1)
      {
        return new CellRange(0, cellRange.Column, rowCount, cellRange.ColumnCount);
      }
      else if (cellRange.Column == -1)
      {
        return new CellRange(cellRange.Row, 0, cellRange.RowCount, columnCount);
      }

      return cellRange;
    }

    private void Merge_Click(object sender, EventArgs e)
    {
      SheetView sheet = this.fpSpread1.ActiveSheet;

      foreach (CellRange cellRange in sheet.GetSelections())
      {
        CellRange range = GetActualCellRange(cellRange, sheet.RowCount, sheet.ColumnCount);
        sheet.Cells[range.Row, range.Column].RowSpan = range.RowCount;
        sheet.Cells[range.Row, range.Column].ColumnSpan = range.ColumnCount;
      }
    }

    private void UnMerge_Click(object sender, EventArgs e)
    {
      SheetView sheet = this.fpSpread1.ActiveSheet;
      foreach (CellRange cellRange in sheet.GetSelections())
      {
        CellRange range = GetActualCellRange(cellRange, sheet.RowCount, sheet.ColumnCount);
        for (int i = 0; i < range.RowCount; i++)
        {
          for (int j = 0; j < range.ColumnCount; j++)
          {
            sheet.Cells[range.Row + i, range.Column + j].RowSpan = 1;
            sheet.Cells[range.Row + i, range.Column + j].ColumnSpan = 1;
          }
        }
      }

    }
  }
}
