﻿using System;
using System.Data;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;

namespace SpreadWinDemo.Features
{
    public partial class Databinding : Form
    {
        public Databinding()
        {
            InitializeComponent();
        }

        static string GetDBPath()
    {
      string dbPath = string.Empty;
      string fileName = "\\Nwind.mdb";
      RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");
      if (regKey != null)
        dbPath = (string)regKey.GetValue("v" + GCVersionUtil.ProductVersion);
      if (!File.Exists(dbPath + fileName))
        dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER + "\\Common\\";
      if (!File.Exists(dbPath + fileName))
        dbPath = "Data\\";
      dbPath += fileName;     
      return dbPath;
    }

    static public DataSet GetNWINDData(string dt)
    {
      string sqlStr = "SELECT * FROM " + dt;
      return GetNWINDDataComplete(sqlStr);
    }

    static public DataSet GetNWINDDataComplete(string sqlStr)
    {
      string conStr = "Provider=Microsoft.JET.OLEDB.4.0;data source=" + GetDBPath();
      System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection(conStr);
      DataSet ds = new DataSet();
      System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter(sqlStr, conn);
      da.Fill(ds);
      return ds;
    }

    private void databinding_Load(object sender, System.EventArgs e)
    {
      string dbpath = GetDBPath();

      oleDbConnection1.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + dbpath;
      oleDbDataAdapter1.Fill(dataSet1);
      FpSpread1.DataSource = dataSet1;
    }

    private void button1_Click(object sender, System.EventArgs e)
    {
      //Get the data from Spread
      System.Data.DataSet ds;
      ds = (System.Data.DataSet)FpSpread1.Sheets[0].DataSource;

      //Save the changes back to the database
      try
      {
        oleDbDataAdapter1.Update(ds, "Customers");
        ds.AcceptChanges();
        FpSpread1.ActiveSheet.GetDataView(true);
      }
      catch (System.Exception)
      {
      }
    }
    }
}