using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SpreadWinDemo.DragFill
{
  public partial class DragFill : Form
  {
    public DragFill()
    {
      InitializeComponent();
    }

    private void dragFill_Load(object sender, EventArgs e)
    {
      FpSpread1.ActiveSheet.Cells[0, 1].Text = "Sample Drag-fill data";
      FpSpread1.ActiveSheet.Columns[1].Width = 120;
      FpSpread1.ActiveSheet.Columns[2].Width = 120;
      FpSpread1.DragFillDataOnly = false;
      // Set the active cell to the one with text
      FpSpread1.ActiveSheet.SetActiveCell(0, 1);
      // Default to true
      ckAllowFill.Checked = true;
      ckEnableDragFillMenu.Checked = true;
      ckDragFillDataOnly.Checked = false;
      //>>137173 Hans 2015.11.12
      foreach (var mode in Enum.GetValues(typeof(FarPoint.Win.Spread.DragFillMode)))
      {
        cbDragFillMode.Items.Add(mode);
      }
      cbDragFillMode.SelectedIndex = 0;
      //<<137173 Hans 2015.11.12


      foreach (FarPoint.Win.Spread.SheetSkin sk in FarPoint.Win.Spread.DefaultSkins.Skins)
      {
        cbSkin.Items.Add(sk.Name);
      }
      cbSkin.SelectedIndex = 0;
    }

    private void ckAllowFill_CheckedChanged(object sender, EventArgs e)
    {

      if (ckAllowFill.Checked)
      {
        // Allow
        FpSpread1.AllowDragFill = true;
      }
      else
      {
        // Deny
        FpSpread1.AllowDragFill = false;
      }
    }

    //>>137173 Hans 2015.11.12
    private void cbDragFillMode_SelectedIndexChanged(object sender, EventArgs e)
    {
      FpSpread1.RangeDragFillMode = ((FarPoint.Win.Spread.DragFillMode)cbDragFillMode.SelectedItem);

    }

    private void cbEnableDragFillMenu_CheckedChanged(object sender, EventArgs e)
    {
      if (ckEnableDragFillMenu.Checked)
      {
        // Allow
        FpSpread1.EnableDragFillMenu = true;
        cbDragFillMode.Enabled = false;
      }
      else
      {
        // Deny
        FpSpread1.EnableDragFillMenu = false;
        cbDragFillMode.Enabled = true;
      }
    }


    private void cbSkin_SelectedIndexChanged(object sender, EventArgs e)
    {
      FarPoint.Win.Spread.DefaultSkins.GetAt(cbSkin.SelectedIndex).Apply(FpSpread1);

    }
    FarPoint.Win.Spread.CellType.DateTimeCellType date = new FarPoint.Win.Spread.CellType.DateTimeCellType();
    private void cbData_SelectedIndexChanged(object sender, EventArgs e)
    {
      FpSpread1.ActiveSheet.Reset();
      FarPoint.Win.Spread.DefaultSkins.GetAt(cbSkin.SelectedIndex).Apply(FpSpread1);
      FpSpread1.ActiveSheet.Cells[0, 1].Text = "Sample Drag-fill data";
      FpSpread1.ActiveSheet.Columns[1].Width = 120;
      FpSpread1.ActiveSheet.Columns[2].Width = 120;
      FpSpread1.ActiveSheet.Cells[1, 2, 6, 2].BackColor = Color.LightYellow;
      FpSpread1.ActiveSheet.Cells[1, 2, 6, 2].ForeColor = Color.Green;

      switch (cbData.SelectedIndex)
      {
        case 0:

          for (int i = 1; i < 6; i++)
          {
            FpSpread1.ActiveSheet.Cells[i, 2].Value = i;
          }
          break;
        case 1:

          for (int i = 1; i < 6; i++)
          {
            FpSpread1.ActiveSheet.Cells[i, 2].Value = i.ToString();
          }
          break;
        case 2:

          for (int i = 1; i < 6; i++)
          {
            FpSpread1.ActiveSheet.Cells[i, 2].Value = "Drag-fill data";
          }
          break;
        case 3:

          for (int i = 1; i < 6; i++)
          {
            FpSpread1.ActiveSheet.Cells[i, 2].Value = i + 1000;
            FpSpread1.ActiveSheet.Cells[i, 2].CellType = date;
          }
          break;
        case 4:
          FpSpread1.ActiveSheet.Cells[1, 2].Text = "Date 1";
          FpSpread1.ActiveSheet.Cells[2, 2].Value = 1010;
          FpSpread1.ActiveSheet.Cells[2, 2].CellType = date;

          FpSpread1.ActiveSheet.Cells[3, 2].Text = "Date 1";
          FpSpread1.ActiveSheet.Cells[4, 2].Value = 1010;
          FpSpread1.ActiveSheet.Cells[4, 2].CellType = date;

          FpSpread1.ActiveSheet.Cells[5, 2].Text = "Date 1";
          FpSpread1.ActiveSheet.Cells[6, 2].Value = 1010;
          FpSpread1.ActiveSheet.Cells[6, 2].CellType = date;

          break;

      }
    }

    private void ckDragFillDataOnly_CheckedChanged(object sender, EventArgs e)
    {
      if (ckDragFillDataOnly.Checked)
      {
        // Allow
        FpSpread1.DragFillDataOnly = true;
      }
      else
      {
        // Deny
        FpSpread1.DragFillDataOnly = false;
      }
    }
  }
}