using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;

namespace SpreadWinDemo.MoveRowCol
{
  public partial class MoveRowCol : Form
  {
    public MoveRowCol()
    {
      InitializeComponent();
    }

    private void moveRowCol_Load(object sender, EventArgs e)
    {
      string dbPath = string.Empty;
      string fileName = "\\fpnorthwinds.mdb";
      RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");
      if (regKey != null)
        dbPath = (string)regKey.GetValue("v" + GCVersionUtil.ProductVersion);
      if (!File.Exists(dbPath + fileName))
        dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER + "\\Common\\";
      if (!File.Exists(dbPath + fileName))
        dbPath = "Data\\";
      dbPath += fileName;

      string conStr = "Provider=Microsoft.JET.OLEDB.4.0;data source= " + dbPath;
      string sqlStr = "Select * from Customers";
      System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection(conStr);
      DataSet ds = new DataSet();
      System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter(sqlStr, conn);
      da.Fill(ds);
      FpSpread1.ActiveSheet.DataSource = ds;
      ckRowMove.Checked = false;
      ckColMove.Checked = false;
      ckAllowMultiColumnMove.Checked = false;
      ckAllowMultiRowMov.Checked = false;
    }

    private void ckRowMove_CheckedChanged(object sender, EventArgs e)
    {
      if (ckRowMove.Checked)
      {
        // Allow
        FpSpread1.AllowRowMove = true;
      }
      else
      {
        // Prevent
        FpSpread1.AllowRowMove = false;
      }
    }

    private void ckColMove_CheckedChanged(object sender, EventArgs e)
    {


      if (ckColMove.Checked)
      {
        // Allow
        FpSpread1.AllowColumnMove = true;
      }
      else
      {
        // Prevent
        FpSpread1.AllowColumnMove = false;
      }
    }

    private void FpSpread1_ColumnDragMove(object sender, FarPoint.Win.Spread.DragMoveEventArgs e)
    {
      e.MoveContent = false;
    }

    private void ckAllowMultiRowMov_CheckedChanged(object sender, EventArgs e)
    {
      if (ckAllowMultiRowMov.Checked)
      {
        // Allow
        FpSpread1.AllowRowMoveMultiple = true;
      }
      else
      {
        // Prevent
        FpSpread1.AllowRowMoveMultiple = false;
      }
    }

    private void ckAllowMultiColumnMove_CheckedChanged(object sender, EventArgs e)
    {
      if (ckAllowMultiColumnMove.Checked)
      {
        // Allow
        FpSpread1.AllowColumnMoveMultiple = true;
      }
      else
      {
        // Prevent
        FpSpread1.AllowColumnMoveMultiple = false;
      }
    }

    //>>137173 Hans 2015.11.12
    private void ckShowDragBandOnMoving_CheckedChanged(object sender, EventArgs e)
    {
      if (ckShowDragBandOnMoving.Checked)
      {
        // Allow
        FpSpread1.ShowDragBandOnMoving = true;
      }
      else
      {
        // Prevent
        FpSpread1.ShowDragBandOnMoving = false;
      }
    }
    //<<137173 Hans 2015.11.12

  }//end class
}//end namespace
