using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SpreadWinDemo.Notes
{
  public partial class Notes : Form
  {
    public Notes()
    {
      InitializeComponent();
    }

    private void notes_Load(object sender, EventArgs e)
    {

      //Set the coll width
      FpSpread1.ActiveSheet.Columns[1].Width = 100;
      //Add text
      FpSpread1.ActiveSheet.Cells[1, 1].Text = "Note in this cell!";

      //Add the cell note
      FpSpread1.ActiveSheet.Cells[1, 1].Note = "This is a cell note that can contain additional information about the contents of this cell.";
      //Default the note style
      FpSpread1.ActiveSheet.Cells[1, 1].NoteStyle = FarPoint.Win.Spread.NoteStyle.PopupNote;
    }

    private void rbPopup_CheckedChanged(object sender, EventArgs e)
    {
      FpSpread1.ActiveSheet.Cells[1, 1].NoteStyle = FarPoint.Win.Spread.NoteStyle.PopupNote;
      // Enable editing checkbox
      ckAllowEditing.Enabled = false;


    }

    private void rbSticky_CheckedChanged(object sender, EventArgs e)
    {
      FpSpread1.ActiveSheet.Cells[1, 1].NoteStyle = FarPoint.Win.Spread.NoteStyle.StickyNote;
      //Disable editing checkbox
      ckAllowEditing.Enabled = true;
    }

    private void ckAllowEditing_CheckedChanged(object sender, EventArgs e)
    {
      if (ckAllowEditing.Checked)
      {
        FpSpread1.Sheets[0].AllowNoteEdit = true;
      }
      else
      {
        FpSpread1.Sheets[0].AllowNoteEdit = false;
      }


    }


  }//end class
}//end namespace