using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using System.IO;

namespace SpreadWinDemo.Search
{
  public partial class Search : Form
  {
    public Search()
    {
      InitializeComponent();
    }

    private void search_Load(object sender, EventArgs e)
    {
      string dbPath = string.Empty;
      string fileName = "\\fpnorthwinds.mdb";
      RegistryKey regKey = Registry.ClassesRoot.OpenSubKey("FarPoint.Win.Spread\\Common7");
      if (regKey != null)
        dbPath = (string)regKey.GetValue("v" + GCVersionUtil.ProductVersion);
      if (!File.Exists(dbPath + fileName))
        dbPath = Environment.GetFolderPath(Environment.SpecialFolder.ProgramFiles) + GCVersionUtil.SPREAD_INSTALLATION_FOLDER +  "\\Common\\";
      if (!File.Exists(dbPath + fileName))
        dbPath = "Data\\";
      dbPath += fileName;

      string conStr = "Provider=Microsoft.JET.OLEDB.4.0;data source= " + dbPath;
      string sqlStr = "Select * from Customers";
      System.Data.OleDb.OleDbConnection conn = new System.Data.OleDb.OleDbConnection(conStr);
      DataSet ds = new DataSet();
      System.Data.OleDb.OleDbDataAdapter da = new System.Data.OleDb.OleDbDataAdapter(sqlStr, conn);
      da.Fill(ds);
      FpSpread1.ActiveSheet.DataSource = ds;
    }

    private void btnSearch_Click(object sender, EventArgs e)
    {
      if (rbStandard.Checked)
      {
        // Standard Search
        FpSpread1.SearchWithDialog(FpSpread1.ActiveSheetIndex, "", false, false, false, false, 0, 0);
      }
      else
      {
        // Advanced Search
        FpSpread1.SearchWithDialogAdvanced(FpSpread1.ActiveSheetIndex, FpSpread1.ActiveSheetIndex, "", false, false, false, false, 0, 0);
      }
    }

    private void btnProgSearch_Click(object sender, EventArgs e)
    {
      int rowIndex = 0;
      int colIndex = 0;
      int cnt;
      int rowCnt;
      int colCnt;
      int startRow;
      int startCol;
      // Clear the listbox
      lbResults.Items.Clear();
      // Search for the specified item programatically
      rowCnt = (FpSpread1.ActiveSheet.RowCount - 1);
      colCnt = (FpSpread1.ActiveSheet.ColumnCount - 1);
      // Init vars
      startRow = 0;
      startCol = 0;
      cnt = 0;
      while (((rowIndex != -1)
                  && ((colIndex != -1)
                  && (cnt <= rowCnt))))
      {
        // Do Search
        //   returns the matching row(rowIndex) and col number(colIndex) if found
        //   returns -1 if not found
        FpSpread1.Search(FpSpread1.ActiveSheetIndex, txtSearch.Text, false, false, false, false, startRow, startCol, rowCnt, colCnt, ref rowIndex, ref colIndex);
        // Add to the listbox
        if (((rowIndex != -1)
                    && (colIndex != -1)))
        {
          // Found a match. List it.
          // NOTE: For display purposes, display the row/col numbers as the user sees them (1 based), 
          //    not 0 based as Spread uses.  Hence the adding of 1 to the display results
          lbResults.Items.Add(("row="
                          + ((rowIndex + 1) + (", col="
                          + (colIndex + 1)))));
        }
        // Increment the starting row
        if (((rowIndex != -1)
                    && (rowIndex != startRow)))
        {
          // Increment the starting column
          startRow = (rowIndex + 1);
          startCol = 0;
        }
        else if (((colIndex != -1)
                    && (startRow == rowIndex)))
        {
          startCol = (colIndex + 1);
        }
        cnt = (cnt + 1);
      }
      // If no matches found, display message
      if ((lbResults.Items.Count == 0))
      {
        lbResults.Items.Add("No Matches found.");
      }


    }



  }//end class
}//end namespace
