using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SpreadWinDemo.Shapes
{
    public partial class Shapes : Form
    {
        FarPoint.Win.Spread.DrawingSpace.DrawingToolbar draw;

        public Shapes()
        {
            InitializeComponent();

            this.FormClosing += Shapes_FormClosing;
            FpSpread1.CellClick += FpSpread1_CellClick;
        }

        void FpSpread1_CellClick(object sender, FarPoint.Win.Spread.CellClickEventArgs e)
        {
            CloseToolbar();
        }

        void Shapes_FormClosing(object sender, FormClosingEventArgs e)
        {
            CloseToolbar();
        }

        private void CloseToolbar()
        {
            if (this.draw != null)
            {
                this.draw.Close();
                this.draw.Dispose();
            }
        }


        private void shapes_Load(object sender, EventArgs e)
        {
            FpSpread1.ActiveSheet.Cells[2, 2].Text = "Start here!";
            FpSpread1.ActiveSheet.Cells[6, 1].Text = "Create your own shapes now using the toolbar.";
            FpSpread1.ActiveSheet.Cells[6, 1].Font = new Font("Arial", 10, FontStyle.Bold);
            // Allow text to overflow
            FpSpread1.AllowCellOverflow = true;
            CreateArrowShape();
        }

        void CreateArrowShape()
        {
            FarPoint.Win.Spread.DrawingSpace.ArrowShape arrow = new FarPoint.Win.Spread.DrawingSpace.ArrowShape();
            arrow.Name = "myArrow";
            arrow.BackColor = Color.Plum;
            arrow.ForeColor = Color.Pink;
            arrow.SetBounds(65, 38, 50, 25);
            FpSpread1.ActiveSheet.AddShape(arrow);
        }

        void ShowToolbar()
        {
            if (draw != null)
            {
                draw.Dispose();
            }
            //  place this code whereever you want to instantiate the drawing toolbar
            if (!(FpSpread1.ActiveSheet == null))
            {
                draw = new FarPoint.Win.Spread.DrawingSpace.DrawingToolbar(FpSpread1, FpSpread1.ActiveSheet.DrawingContainer);
            }
            else
            {
                draw = new FarPoint.Win.Spread.DrawingSpace.DrawingToolbar(FpSpread1, null);
            }
            draw.Visible = true;
            draw.Owner = this;
            draw.Left = (this.Left
                        + (this.Width
                        - (draw.Width / 2)));
            draw.Top = (this.Top
                        + ((this.Height / 2)
                        - (draw.Height / 2)));
        }

        private void FpSpread1_ShapeActivated(object sender, EventArgs e)
        {
            ShowToolbar();
        }

    }//end class
}//end namespace